
#include "usart.h"
#include "debug.h"

void DMA1_Channel2_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));

u16 i = 0;

//SRC_BUFΪDMAԴݴ洢ڲFLASH
u32 TxBuffer1[TxSize1]=
                      {      0x01020304,0x05060708,0x090A0B0C,0x0D0E0F10,
                             0x11121314,0x15161718,0x191A1B1C,0x1D1E1F20,
                             0x21222324,0x25262728,0x292A2B2C,0x2D2E2F30,
                             0x31323334,0x35363738,0x393A3B3C,0x3D3E3F40,
                             0x41424344,0x45464748,0x494A4B4C,0x4D4E4F50,
                             0x51525354,0x55565758,0x595A5B5C,0x5D5E5F60,
                             0x61626364,0x65666768,0x696A6B6C,0x6D6E6F70,
                             0x71727374,0x75767778,0x797A7B7C,0x7D7E7F80
                      };

/*******************************************************************************
* Function Name  : USARTx_CFG
* Description    : Initializes the USART2 & USART3 peripheral.
* Input          : None
* Return         : None
*******************************************************************************/
void USARTx_CFG(void)
{

    GPIO_InitTypeDef  GPIO_InitStructure;
    USART_InitTypeDef USART_InitStructure;

    //ʹܿGPIOBUSART3ʱ
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB , ENABLE);
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART3, ENABLE);

    //3ӦGPIOųʼ
    /* USART3 TX-->B.10  RX-->B.11 */
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOB, &GPIO_InitStructure);
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_11;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
    GPIO_Init(GPIOB, &GPIO_InitStructure);

    //3ʼ
    USART_InitStructure.USART_BaudRate = 115200;
    USART_InitStructure.USART_WordLength = USART_WordLength_8b;
    USART_InitStructure.USART_StopBits = USART_StopBits_1;
    USART_InitStructure.USART_Parity = USART_Parity_No;
    USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
    USART_InitStructure.USART_Mode = USART_Mode_Tx | USART_Mode_Rx;
    USART_Init(USART3, &USART_InitStructure);

    USART_Cmd(USART3, ENABLE);  //ʹܴ3
}

/*******************************************************************************
* Function Name  : DMA_INIT
* Description    : Configures the DMA for USART3.
* Input          : None
* Return         : None
*******************************************************************************/
void DMA_INIT(void)
{
    DMA_InitTypeDef   DMA_InitStructure;
    NVIC_InitTypeDef  NVIC_InitStructure;

    RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DMA1, ENABLE);                       //ʹܿDMAʱ

    DMA_DeInit(DMA1_Channel2);
    DMA_InitStructure.DMA_PeripheralBaseAddr = (u32)(&USART3->DATAR);        /*DMAԴ3ݼĴַ*/
    DMA_InitStructure.DMA_MemoryBaseAddr = (u32)TxBuffer1;                   /*ڴַ(Ҫıָ)*/
    DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralDST;                       /*򣺴ڴ浽*/
    DMA_InitStructure.DMA_BufferSize = TxSize1;                              /*СDMA_BufferSize=TxSize1*/
    DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable;         /*ַ*/
    DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Enable;                  /*ڴַ*/
    DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_Byte;  /*ݵλ ֽ*/
    DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_Byte;          /*ڴݵλ ֽ*/
    DMA_InitStructure.DMA_Mode = DMA_Mode_Normal;                            /*DMAģʽģʽֻһΡע⣺ADɼ֮ʱҪóѭģʽ*/
    DMA_InitStructure.DMA_Priority = DMA_Priority_VeryHigh;                  /*ȼǳ*/
    DMA_InitStructure.DMA_M2M = DMA_M2M_Disable;                             /*ֹڴ浽ڴĴ*/
    DMA_Init(DMA1_Channel2, &DMA_InitStructure);                             /*DMA12ͨ*/

    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_1);
    NVIC_InitStructure.NVIC_IRQChannel = DMA1_Channel2_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);

    DMA_ITConfig(DMA1_Channel2, DMA_IT_TC, ENABLE);  //ʹDMAж

    DMA_Cmd (DMA1_Channel2,ENABLE);  //ʹDMA
}

void DMA1_Channel2_IRQHandler(void)
{
    if(DMA_GetITStatus(DMA1_IT_TC2))
    {
        printf("USART DMA complete\r\n");
        for(i=0;i<TxSize1;i++)
        {
                printf("0x%08x\r\n",TxBuffer1[i]);
        }
        DMA_ClearITPendingBit(DMA1_IT_TC2); //ȫжϱ־
    }
}
